% % Koya University - Safar Maghdid Asaad 
%
% Copyright (c) 2022, Koya University and Erbil Polytechnic University - Safar Maghdid Asaad 
% *************************************************
% -------------------------------------------------
% FILE       : MSATE_Norm_WkNN.m
% DESCRIPTION: A source code to implement the proposed 
%              SMATE_Norm_WkNN solution
%              based on work of "Safar Mahdid Asaad"
%
% -------------------------------------------------
% *************************************************

clear all
close all
clc

addpath("WKNN/");

for i=1:1
    T1=readtable(sprintf('Original.csv'));
%     sortedNames_WAPs = sort(T1.Properties.VariableNames(3:end));
    sortedNames_WAPs = T1.Properties.VariableNames(3:end);
    T_sorted_Train{i} = [T1(:,1:2) T1(:,sortedNames_WAPs)];
end

% Related to Augmentation (MSATE)
% Augmentation
% T_sorted_Train is a 1x1 cell that contains X Y with 14 RSSI features for
% 14 APs
% N is the number of mimic (imitate) records, here it is 15
% R is the number of original records for each reference point (RP) here it
% is 10
[new_data_set] = Augmentation(T_sorted_Train, 15, 10);


%% normaliz the datasets (Norm)
[new_data_set] = Normalization(new_data_set);

% save new_data_set_Aug_Norm new_data_set

% load new_data_set_Aug_Norm.mat;

%% plot indoor map points
X_Train=new_data_set(:, 1);
Y_Train=new_data_set(:, 2);
figure(1)
plot(X_Train,Y_Train,'-ok');
% Plotting WAPs RSSI values
figure(2)
colors{1}=['*k'];
colors{2}=['*g']; 
colors{3}=['*r']; 
colors{4}=['*b'];
colors{5}=['*m'];
colors{6}=['*c'];
colors{7}=['*y'];
colors{8}=['ok'];
colors{9}=['og'];
legendCell=[];


c=1;
for j=1:1
    RSS_Train=[]; RSS_Test=[];
    for i=1:14
       RSS_Train=[RSS_Train new_data_set(:, i+2)];
    end
    RSS_Train=[new_data_set(:, 1) new_data_set(:, 2) RSS_Train];
    temp=[]; new_y=[];
    for i=1:length(RSS_Train)
        if(mod( i , 5 ) == 0)
            RSS_Test=[RSS_Test; RSS_Train(i,:)];
        else
            temp=[temp; RSS_Train(i,:)];
        end
    end

    RSS_Train=temp; 
    XTrain=RSS_Train(:,3:end);
    XYTrain = RSS_Train(:,1:2);
    
    XTest=RSS_Test(:,3:end);
    XYTest = RSS_Test(:,1:2);

% % % % % % % % % % % % % %     % WKNN      % % % % % % % % % % % % % % 


[X, Y]=W3KNN(XTrain, XYTrain, XTest);

%     --------------------------
for i=1:length(XTest)
       X_predicted_k(i)=X(i);
       Y_predicted_k(i)=Y(i);
       X_true_k(i)=XYTest(i,1);
       Y_true_k(i)=XYTest(i,2);
end

error=[];
for i=1:length(XTest)
        error(i)=sqrt(((X_predicted_k(i)-X_true_k(i))^2+(Y_predicted_k(i)-Y_true_k(i))^2)/2);
end
average_error=mean(error)


figure(3)
cdfplot( error ) 
xlabel('Estimated Positioning Error (meters)')
ylabel('CDF')
end
