% % Koya University - Safar Maghdid Asaad 
%
% Copyright (c) 2022, Koya University and Erbil Polytechnic University - Safar Maghdid Asaad 
% *************************************************
% -------------------------------------------------
% FILE       : W3KNN.m
% DESCRIPTION: A function to find the three weighted nearest neighbers to
%               an RSSI sample.

%              based on work of "Safar Mahdid Asaad"
%
% -------------------------------------------------
% *************************************************
function [pred_x,pred_y] = W3KNN(XTrain,XYTrain, Test)
error=[];
[r c] = size(Test);
for i=1:r
    dis=[];
    for j=1:length(XTrain)
        sum=0;
        for k=1:c
              sum=sum+((XTrain(j,k)) - Test(i,k))^2;
        end 
       dis(j)=sqrt(sum); % similarity distance between test record and all other training records
    end    
    [new_dis,I] = sort(dis,'ascend');
    rand_ignor_infiniti=rand/10000;
    new_dis=new_dis+rand_ignor_infiniti;
    sum_dis=(1/new_dis(1))+(1/new_dis(2))+(1/new_dis(3));
    
    %%where k=3 the accuracy is 1.62
    pred_x1=XYTrain(I(1),1);
    pred_y1=XYTrain(I(1),2);
    pred_x2=XYTrain(I(2),1);
    pred_y2=XYTrain(I(2),2);
    pred_x3=XYTrain(I(3),1);
    pred_y3=XYTrain(I(3),2);

    w1=((1/new_dis(1))/sum_dis);
    w2=((1/new_dis(2))/sum_dis);
    w3=((1/new_dis(3))/sum_dis);
    pred_x(i)=(pred_x1*w1+pred_x2*w2+pred_x3*w3);
    pred_y(i)=(pred_y1*w1+pred_y2*w2+pred_y3*w3);

end

end

